// ObjectViewer3dView.cpp : implementation of the CObjectViewer3dView class
//
/*

  Title:	Object Viewer 3d
  Author:	Claudio Eduardo Storti Lago
  email:	webmaster@computersorcerer.com
  http://www.computersorcerer.com

  ps:	this source can be distributed freely, but you need to
		mention the author's name.

*/
#include "stdafx.h"
#include "ObjectViewer3d.h"

#include "ObjectViewer3dDoc.h"
#include "ObjectViewer3dView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CObjectViewer3dView

IMPLEMENT_DYNCREATE(CObjectViewer3dView, CView)

BEGIN_MESSAGE_MAP(CObjectViewer3dView, CView)
	//{{AFX_MSG_MAP(CObjectViewer3dView)
	ON_COMMAND(ID_PROJECTIONS_CONIC_1POINT, OnProjectionsConic1point)
	ON_COMMAND(ID_PROJECTIONS_CONIC_2POINTS, OnProjectionsConic2points)
	ON_COMMAND(ID_PROJECTIONS_CONIC_3POINTS, OnProjectionsConic3points)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_OBLIQUE_CAVALEIRA, OnProjectionsCylindricObliqueCavaleira)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_OBLIQUE_CABINET, OnProjectionsCylindricObliqueCabinet)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_VISTASORTOGRFICAS_FRENTE, OnProjectionsCylindricOrtogonalVistasortogrficasFrente)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_VISTASORTOGRFICAS_CIMA, OnProjectionsCylindricOrtogonalVistasortogrficasCima)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_VISTASORTOGRFICAS_LATERALDIREITA, OnProjectionsCylindricOrtogonalVistasortogrficasLateraldireita)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_VISTASORTOGRFICAS_LATERALESQUERDA, OnProjectionsCylindricOrtogonalVistasortogrficasLateralesquerda)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_VISTASORTOGRFICAS_INFERIOR, OnProjectionsCylindricOrtogonalVistasortogrficasInferior)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_VISTASORTOGRFICAS_POSTERIOR, OnProjectionsCylindricOrtogonalVistasortogrficasPosterior)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_AXOMTRICAS_ISOMTRICA, OnProjectionsCylindricOrtogonalAxomtricasIsomtrica)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_AXOMTRICAS_DIMTRICA, OnProjectionsCylindricOrtogonalAxomtricasDimtrica)
	ON_COMMAND(ID_PROJECTIONS_CYLINDRIC_ORTOGONAL_AXOMTRICAS_TRIMTRICA, OnProjectionsCylindricOrtogonalAxomtricasTrimtrica)
	ON_COMMAND(ID_PROJECTIONS_ESTREO, OnProjectionsEstreo)
	ON_UPDATE_COMMAND_UI(ID_PROJECTIONS_ESTREO, OnUpdateProjectionsEstreo)
	ON_COMMAND(ID_PROJEES_BACKFACEREMOVE, OnProjeesBackfaceremove)
	ON_UPDATE_COMMAND_UI(ID_PROJEES_BACKFACEREMOVE, OnUpdateProjeesBackfaceremove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CObjectViewer3dView construction/destruction

CObjectViewer3dView::CObjectViewer3dView()
{
	// TODO: add construction code here
	projType="3pts Fuga";
	viewMode=CONICA_3PT_FUGA;
	stereo=false;
	back_remove=false;
}

CObjectViewer3dView::~CObjectViewer3dView()
{
}

BOOL CObjectViewer3dView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CObjectViewer3dView drawing

void CObjectViewer3dView::OnDraw(CDC* pDC)
{
	CObjectViewer3dDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	CRect windowRect;
	int cx,cy;
	int index,index2;
	float zc=300;
	float ty=0;
	float w=10;
	int modoAntigo=pDC->GetROP2();
	float nx,ny,nz;
	float ux,uy,uz;
	float vx,vy,vz;
	bool visible;
	
	pDC->SetROP2(R2_MERGEPEN);

	CPen bluePen(PS_SOLID,2,RGB(0,0,255));
	CPen redPen(PS_SOLID,2,RGB(255,0,0));


	
	//verifica o tamanho da janela
	GetWindowRect(&windowRect);
	
	windowRect.right-=windowRect.left;
	windowRect.bottom-=windowRect.top;
	windowRect.left=0;
	windowRect.top=0;

	pDC->FillSolidRect(windowRect,RGB(0,0,0));

	//calcula os centros da janela
	cx=(int)(windowRect.right/2);
	cy=(int)(windowRect.bottom/2);

	pDC->SetBkColor(RGB(0,0,0));
	pDC->SetTextColor(RGB(255,255,255));
	pDC->TextOut(0,0,"Objeto: "+pDoc->objectName);
	pDC->TextOut(0,20,projType);

	
	if (!stereo){
		pDC->SelectStockObject(WHITE_PEN);
		switch(viewMode){

		case CONICA_1PT_FUGA:
			Projecao1PtFuga(zc,pDoc);
			break;
		case CONICA_2PT_FUGA:
			Projecao2PtFuga(40,ty,zc,pDoc);
			break;
		case CONICA_3PT_FUGA:
			Projecao3PtFuga(30,30,ty,zc,pDoc);
			break;
		case CILINDRICA_OBLIQUA_CAVALEIRA:
			ProjecaoCilindricaObliqua(1,45,pDoc);
			break;
		case CILINDRICA_OBLIQUA_CABINET:
			ProjecaoCilindricaObliqua(.5,45,pDoc);
			break;	
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_FRENTE:
			ProjecaoCilindricaOrtogonal(0,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_CIMA:
			ProjecaoCilindricaOrtogonal(90,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_DIREITA:
			ProjecaoCilindricaOrtogonal(0,-90,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_ESQUERDA:
			ProjecaoCilindricaOrtogonal(0,90,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_INFERIOR:
			ProjecaoCilindricaOrtogonal(-90,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_POSTERIOR:
			ProjecaoCilindricaOrtogonal(0,180,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_AUXILIAR:
			//ProjecaoCilindricaOrtogonal(0,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_ISOMETRICA:
			ProjecaoCilindricaOrtogonal((float)35.27,45,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_DIMETRICA:
			ProjecaoCilindricaOrtogonal((float)48.504,45,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_TRIMETRICA:
			ProjecaoCilindricaOrtogonal((float)14.188,(float)40.523,pDoc);
			break;
		default:
			Projecao3PtFuga(30,30,ty,zc,pDoc);
			break;
		}
		
		//desenha o objeto
		for (index=0;index<pDoc->numPolys;index++){
			//calcula o vetor normal ao poligono
			ux=pDoc->pointsView[pDoc->polys[index].points[1]].x-pDoc->pointsView[pDoc->polys[index].points[0]].x;
			uy=pDoc->pointsView[pDoc->polys[index].points[1]].y-pDoc->pointsView[pDoc->polys[index].points[0]].y;
			uz=pDoc->pointsView[pDoc->polys[index].points[1]].z-pDoc->pointsView[pDoc->polys[index].points[0]].z;

			vx=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].x-pDoc->pointsView[pDoc->polys[index].points[0]].x;
			vy=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].y-pDoc->pointsView[pDoc->polys[index].points[0]].y;
			vz=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].z-pDoc->pointsView[pDoc->polys[index].points[0]].z;

			nx=uz*vy-uy*vz;
			ny=-(uz*vx-ux*vz);
			nz=uy*vx-ux*vy;

			if (nz>=0)
				visible=false;
			else
				visible=true;

			if ((visible && back_remove)||!back_remove){
				if (viewMode==CONICA_1PT_FUGA || viewMode==CONICA_2PT_FUGA || viewMode==CONICA_3PT_FUGA){
					pDC->MoveTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))));
					for (index2=1;index2<pDoc->polys[index].numPoints;index2++){
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[index2]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[index2]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[index2]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[index2]].z/zc))));
					}
					if ((visible && back_remove)||!back_remove)
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))));
				}else{
					pDC->MoveTo(cx+(int)pDoc->pointsView[pDoc->polys[index].points[0]].x,cy-(int)pDoc->pointsView[pDoc->polys[index].points[0]].y);
					for (index2=1;index2<pDoc->polys[index].numPoints;index2++){
						pDC->LineTo(cx+(int)pDoc->pointsView[pDoc->polys[index].points[index2]].x,cy-(int)pDoc->pointsView[pDoc->polys[index].points[index2]].y);
					}
					if ((visible && back_remove)||!back_remove)
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y));
				}
			}
		}	
	
	} else {
		//olho direito
		pDC->SelectObject(&redPen);
		for (index=0;index<pDoc->numPoints;index++)		
			pDoc->points[index].x+=w;

		switch(viewMode){

		case CONICA_1PT_FUGA:
			Projecao1PtFuga(zc,pDoc);
			break;
		case CONICA_2PT_FUGA:
			Projecao2PtFuga(30,ty,zc,pDoc);
			break;
		case CONICA_3PT_FUGA:
			Projecao3PtFuga(30,30,ty,zc,pDoc);
			break;
		case CILINDRICA_OBLIQUA_CAVALEIRA:
			ProjecaoCilindricaObliqua(1,45,pDoc);
			break;
		case CILINDRICA_OBLIQUA_CABINET:
			ProjecaoCilindricaObliqua(.5,45,pDoc);
			break;	
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_FRENTE:
			ProjecaoCilindricaOrtogonal(0,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_CIMA:
			ProjecaoCilindricaOrtogonal(90,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_DIREITA:
			ProjecaoCilindricaOrtogonal(0,-90,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_ESQUERDA:
			ProjecaoCilindricaOrtogonal(0,90,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_INFERIOR:
			ProjecaoCilindricaOrtogonal(-90,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_POSTERIOR:
			ProjecaoCilindricaOrtogonal(0,180,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_AUXILIAR:
			//ProjecaoCilindricaOrtogonal(0,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_ISOMETRICA:
			ProjecaoCilindricaOrtogonal((float)35.27,45,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_DIMETRICA:
			ProjecaoCilindricaOrtogonal((float)48.504,45,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_TRIMETRICA:
			ProjecaoCilindricaOrtogonal((float)14.188,(float)40.523,pDoc);
			break;
		default:
			Projecao3PtFuga(30,30,ty,zc,pDoc);
			break;
		}
		
		//desenha o objeto
		for (index=0;index<pDoc->numPolys;index++){
			//calcula o vetor normal ao poligono
			ux=pDoc->pointsView[pDoc->polys[index].points[1]].x-pDoc->pointsView[pDoc->polys[index].points[0]].x;
			uy=pDoc->pointsView[pDoc->polys[index].points[1]].y-pDoc->pointsView[pDoc->polys[index].points[0]].y;
			uz=pDoc->pointsView[pDoc->polys[index].points[1]].z-pDoc->pointsView[pDoc->polys[index].points[0]].z;

			vx=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].x-pDoc->pointsView[pDoc->polys[index].points[0]].x;
			vy=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].y-pDoc->pointsView[pDoc->polys[index].points[0]].y;
			vz=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].z-pDoc->pointsView[pDoc->polys[index].points[0]].z;

			nx=uz*vy-uy*vz;
			ny=-(uz*vx-ux*vz);
			nz=uy*vx-ux*vy;

			if (nz>=0)
				visible=false;
			else
				visible=true;

			if ((visible && back_remove)||!back_remove){
				if (viewMode==CONICA_1PT_FUGA || viewMode==CONICA_2PT_FUGA || viewMode==CONICA_3PT_FUGA){
					pDC->MoveTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))));
					for (index2=1;index2<pDoc->polys[index].numPoints;index2++){
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[index2]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[index2]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[index2]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[index2]].z/zc))));
					}
					if ((visible && back_remove)||!back_remove)
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))));
				}else{
					pDC->MoveTo(cx+(int)pDoc->pointsView[pDoc->polys[index].points[0]].x,cy-(int)pDoc->pointsView[pDoc->polys[index].points[0]].y);
					for (index2=1;index2<pDoc->polys[index].numPoints;index2++){
						pDC->LineTo(cx+(int)pDoc->pointsView[pDoc->polys[index].points[index2]].x,cy-(int)pDoc->pointsView[pDoc->polys[index].points[index2]].y);
					}
					if ((visible && back_remove)||!back_remove)
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y));
				}
			}
		}	
		//olho esquerdo
		pDC->SelectObject(&bluePen);
		for (index=0;index<pDoc->numPoints;index++)		
			pDoc->points[index].x-=(2*w);

		switch(viewMode){

		case CONICA_1PT_FUGA:
			Projecao1PtFuga(zc,pDoc);
			break;
		case CONICA_2PT_FUGA:
			Projecao2PtFuga(30,ty,zc,pDoc);
			break;
		case CONICA_3PT_FUGA:
			Projecao3PtFuga(30,30,ty,zc,pDoc);
			break;
		case CILINDRICA_OBLIQUA_CAVALEIRA:
			ProjecaoCilindricaObliqua(1,45,pDoc);
			break;
		case CILINDRICA_OBLIQUA_CABINET:
			ProjecaoCilindricaObliqua(.5,45,pDoc);
			break;	
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_FRENTE:
			ProjecaoCilindricaOrtogonal(0,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_CIMA:
			ProjecaoCilindricaOrtogonal(90,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_DIREITA:
			ProjecaoCilindricaOrtogonal(0,-90,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_ESQUERDA:
			ProjecaoCilindricaOrtogonal(0,90,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_INFERIOR:
			ProjecaoCilindricaOrtogonal(-90,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_POSTERIOR:
			ProjecaoCilindricaOrtogonal(0,180,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_ORTOGRAFICA_AUXILIAR:
			//ProjecaoCilindricaOrtogonal(0,0,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_ISOMETRICA:
			ProjecaoCilindricaOrtogonal((float)35.27,45,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_DIMETRICA:
			ProjecaoCilindricaOrtogonal((float)48.504,45,pDoc);
			break;
		case CILINDRICA_ORTOGONAL_AXONOMETRICAS_TRIMETRICA:
			ProjecaoCilindricaOrtogonal((float)14.188,(float)40.523,pDoc);
			break;
		default:
			Projecao3PtFuga(30,30,ty,zc,pDoc);
			break;
		}
		
		//desenha o objeto
		for (index=0;index<pDoc->numPolys;index++){
			//calcula o vetor normal ao poligono
			ux=pDoc->pointsView[pDoc->polys[index].points[1]].x-pDoc->pointsView[pDoc->polys[index].points[0]].x;
			uy=pDoc->pointsView[pDoc->polys[index].points[1]].y-pDoc->pointsView[pDoc->polys[index].points[0]].y;
			uz=pDoc->pointsView[pDoc->polys[index].points[1]].z-pDoc->pointsView[pDoc->polys[index].points[0]].z;

			vx=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].x-pDoc->pointsView[pDoc->polys[index].points[0]].x;
			vy=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].y-pDoc->pointsView[pDoc->polys[index].points[0]].y;
			vz=pDoc->pointsView[pDoc->polys[index].points[pDoc->polys[index].numPoints-1]].z-pDoc->pointsView[pDoc->polys[index].points[0]].z;

			nx=uz*vy-uy*vz;
			ny=-(uz*vx-ux*vz);
			nz=uy*vx-ux*vy;

			if (nz>=0)
				visible=false;
			else
				visible=true;

			if ((visible && back_remove)||!back_remove){
				if (viewMode==CONICA_1PT_FUGA || viewMode==CONICA_2PT_FUGA || viewMode==CONICA_3PT_FUGA){
					pDC->MoveTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))));
					for (index2=1;index2<pDoc->polys[index].numPoints;index2++){
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[index2]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[index2]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[index2]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[index2]].z/zc))));
					}
					if ((visible && back_remove)||!back_remove)
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y/(1-(pDoc->pointsView[pDoc->polys[index].points[0]].z/zc))));
				}else{
					pDC->MoveTo(cx+(int)pDoc->pointsView[pDoc->polys[index].points[0]].x,cy-(int)pDoc->pointsView[pDoc->polys[index].points[0]].y);
					for (index2=1;index2<pDoc->polys[index].numPoints;index2++){
						pDC->LineTo(cx+(int)pDoc->pointsView[pDoc->polys[index].points[index2]].x,cy-(int)pDoc->pointsView[pDoc->polys[index].points[index2]].y);
					}
					if ((visible && back_remove)||!back_remove)
						pDC->LineTo(cx+(int)(pDoc->pointsView[pDoc->polys[index].points[0]].x),cy-(int)(pDoc->pointsView[pDoc->polys[index].points[0]].y));
				}
			}
		}	

	for (index=0;index<pDoc->numPoints;index++)		
		pDoc->points[index].x+=w;

	}
	
	pDC->SetROP2(modoAntigo);
}

/////////////////////////////////////////////////////////////////////////////
// CObjectViewer3dView diagnostics

#ifdef _DEBUG
void CObjectViewer3dView::AssertValid() const
{
	CView::AssertValid();
}

void CObjectViewer3dView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CObjectViewer3dDoc* CObjectViewer3dView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CObjectViewer3dDoc)));
	return (CObjectViewer3dDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CObjectViewer3dView message handlers

void CObjectViewer3dView::ProjecaoCilindricaOrtogonal(float a, float b, CObjectViewer3dDoc * pDoc)
{
	int index;

	a=(float)((a/180)*PI);
	b=(float)((b/180)*PI);

	for (index=0;index<pDoc->numPoints;index++){
		pDoc->pointsView[index].x=(float)(pDoc->points[index].x*cos(b)
							+sin(b)*pDoc->points[index].z);

		pDoc->pointsView[index].y=(float)(sin(a)*sin(b)*pDoc->points[index].x
								+cos(a)*pDoc->points[index].y
								-sin(a)*cos(b)*pDoc->points[index].z);

		pDoc->pointsView[index].z=(float)(-sin(b)*cos(a)*pDoc->points[index].x
								+sin(a)*pDoc->points[index].y
								+cos(a)*cos(b)*pDoc->points[index].z);

	}
}

void CObjectViewer3dView::ProjecaoCilindricaObliqua(float r, float b, CObjectViewer3dDoc * pDoc)
{
int index;

	b=(float)((b/180)*PI);

	for (index=0;index<pDoc->numPoints;index++){
		pDoc->pointsView[index].x=(float)(pDoc->points[index].x 
							+r*cos(b)*pDoc->points[index].z);

		pDoc->pointsView[index].y=(float)(pDoc->points[index].y
							-r*sin(b)*pDoc->points[index].z);

		pDoc->pointsView[index].z=pDoc->points[index].z;
	}
}

void CObjectViewer3dView::Projecao1PtFuga(float zc, CObjectViewer3dDoc * pDoc)
{
	int index;

	for (index=0;index<pDoc->numPoints;index++){
		pDoc->pointsView[index].x=pDoc->points[index].x;
		pDoc->pointsView[index].y=pDoc->points[index].y;
		pDoc->pointsView[index].z=pDoc->points[index].z;
	}
}

void CObjectViewer3dView::Projecao2PtFuga(float b, float ty, float zc, CObjectViewer3dDoc * pDoc)
{
	int index;

	b=(float)((b/180)*PI);

	for (index=0;index<pDoc->numPoints;index++){
		pDoc->pointsView[index].x=(float)(cos(b)*pDoc->points[index].x-sin(b)*pDoc->points[index].z);
		pDoc->pointsView[index].y=pDoc->points[index].y+ty;
		pDoc->pointsView[index].z=(float)(sin(b)*pDoc->points[index].x+cos(b)*pDoc->points[index].z);
	}

}

void CObjectViewer3dView::Projecao3PtFuga(float a, float b, float ty, float zc, CObjectViewer3dDoc * pDoc)
{
	int index;

	a=(float)((a/180)*PI);
	b=(float)((b/180)*PI);

	for (index=0;index<pDoc->numPoints;index++){
		pDoc->pointsView[index].x=(float)(cos(b)*pDoc->points[index].x
							+sin(b)*pDoc->points[index].z);

		pDoc->pointsView[index].y=(float)(sin(a)*sin(b)*pDoc->points[index].x
							+cos(a)*pDoc->points[index].y
							-sin(a)*cos(b)*pDoc->points[index].z
							+ty);

		pDoc->pointsView[index].z=(float)(-cos(a)*sin(b)*pDoc->points[index].x
							+sin(a)*pDoc->points[index].y
							+cos(a)*cos(b)*pDoc->points[index].z);
	}
}

void CObjectViewer3dView::OnProjectionsConic1point() 
{
	// TODO: Add your command handler code here
	viewMode=CONICA_1PT_FUGA;
	projType="1pt Fuga";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsConic2points() 
{
	// TODO: Add your command handler code here
	viewMode=CONICA_2PT_FUGA;
	projType="2pts Fuga";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsConic3points() 
{
	// TODO: Add your command handler code here
	viewMode=CONICA_3PT_FUGA;
	projType="3pts Fuga";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricObliqueCavaleira() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_OBLIQUA_CAVALEIRA;
	projType="Cavaleira";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricObliqueCabinet() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_OBLIQUA_CABINET;	
	projType="Cabinet";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalVistasortogrficasFrente() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_ORTOGRAFICA_FRENTE;
	projType="Ortogrfica Frente";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalVistasortogrficasCima() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_ORTOGRAFICA_CIMA;
	projType="Ortogrfica Cima";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalVistasortogrficasLateraldireita() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_DIREITA;
	projType="Ortogrfica Lateral Direita";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalVistasortogrficasLateralesquerda() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_ESQUERDA;
	projType="Ortogrfica Lateral Esquerda";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalVistasortogrficasInferior() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_ORTOGRAFICA_INFERIOR;
	projType="Ortogrfica Inferior";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalVistasortogrficasPosterior() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_ORTOGRAFICA_POSTERIOR;
	projType="Ortogrfica Posterior";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalAxomtricasIsomtrica() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_AXONOMETRICAS_ISOMETRICA;
	projType="Ortogonal Isomtrica";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalAxomtricasDimtrica() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_AXONOMETRICAS_DIMETRICA;	
	projType="Ortogonal Dimtrica";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsCylindricOrtogonalAxomtricasTrimtrica() 
{
	// TODO: Add your command handler code here
	viewMode=CILINDRICA_ORTOGONAL_AXONOMETRICAS_TRIMETRICA;
	projType="Ortogonal Trimtrica";
	Invalidate();
}

void CObjectViewer3dView::OnProjectionsEstreo() 
{
	// TODO: Add your command handler code here
	stereo=!stereo;
	Invalidate();
}

void CObjectViewer3dView::OnUpdateProjectionsEstreo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(stereo);
	
}

void CObjectViewer3dView::OnProjeesBackfaceremove() 
{
	// TODO: Add your command handler code here
	back_remove=!back_remove;
	Invalidate();
	
}

void CObjectViewer3dView::OnUpdateProjeesBackfaceremove(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(back_remove);
}
