// ObjectViewer3dView.h : interface of the CObjectViewer3dView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OBJECTVIEWER3DVIEW_H__439861ED_E981_11D4_83CE_004033E136DA__INCLUDED_)
#define AFX_OBJECTVIEWER3DVIEW_H__439861ED_E981_11D4_83CE_004033E136DA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define CONICA_1PT_FUGA 0
#define CONICA_2PT_FUGA 1
#define CONICA_3PT_FUGA 2
#define CILINDRICA_OBLIQUA_CAVALEIRA 3
#define CILINDRICA_OBLIQUA_CABINET 4
#define CILINDRICA_ORTOGONAL_ORTOGRAFICA_FRENTE 5
#define CILINDRICA_ORTOGONAL_ORTOGRAFICA_CIMA 6
#define CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_DIREITA 7
#define CILINDRICA_ORTOGONAL_ORTOGRAFICA_LATERAL_ESQUERDA 8
#define CILINDRICA_ORTOGONAL_ORTOGRAFICA_INFERIOR 9
#define CILINDRICA_ORTOGONAL_ORTOGRAFICA_POSTERIOR 10
#define CILINDRICA_ORTOGONAL_ORTOGRAFICA_AUXILIAR 11
#define CILINDRICA_ORTOGONAL_AXONOMETRICAS_ISOMETRICA 12
#define CILINDRICA_ORTOGONAL_AXONOMETRICAS_DIMETRICA 13
#define CILINDRICA_ORTOGONAL_AXONOMETRICAS_TRIMETRICA 14

#define PI 3.14159265358979323846

#include <math.h>

class CObjectViewer3dView : public CView
{
protected: // create from serialization only
	CObjectViewer3dView();
	DECLARE_DYNCREATE(CObjectViewer3dView)

// Attributes
public:
	CObjectViewer3dDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CObjectViewer3dView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CObjectViewer3dView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CObjectViewer3dView)
	afx_msg void OnProjectionsConic1point();
	afx_msg void OnProjectionsConic2points();
	afx_msg void OnProjectionsConic3points();
	afx_msg void OnProjectionsCylindricObliqueCavaleira();
	afx_msg void OnProjectionsCylindricObliqueCabinet();
	afx_msg void OnProjectionsCylindricOrtogonalVistasortogrficasFrente();
	afx_msg void OnProjectionsCylindricOrtogonalVistasortogrficasCima();
	afx_msg void OnProjectionsCylindricOrtogonalVistasortogrficasLateraldireita();
	afx_msg void OnProjectionsCylindricOrtogonalVistasortogrficasLateralesquerda();
	afx_msg void OnProjectionsCylindricOrtogonalVistasortogrficasInferior();
	afx_msg void OnProjectionsCylindricOrtogonalVistasortogrficasPosterior();
	afx_msg void OnProjectionsCylindricOrtogonalAxomtricasIsomtrica();
	afx_msg void OnProjectionsCylindricOrtogonalAxomtricasDimtrica();
	afx_msg void OnProjectionsCylindricOrtogonalAxomtricasTrimtrica();
	afx_msg void OnProjectionsEstreo();
	afx_msg void OnUpdateProjectionsEstreo(CCmdUI* pCmdUI);
	afx_msg void OnProjeesBackfaceremove();
	afx_msg void OnUpdateProjeesBackfaceremove(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool back_remove;
	bool stereo;
	CString projType;
	void Projecao3PtFuga(float a,float b, float ty, float zc, CObjectViewer3dDoc * pDoc);
	void Projecao2PtFuga(float b, float ty,float zc,CObjectViewer3dDoc* pDoc);
	void Projecao1PtFuga(float zc,CObjectViewer3dDoc* pDoc);
	void ProjecaoCilindricaObliqua(float r, float b, CObjectViewer3dDoc* pDoc);
	int viewMode;
	void ProjecaoCilindricaOrtogonal(float a, float b,CObjectViewer3dDoc* pDoc);
};

#ifndef _DEBUG  // debug version in ObjectViewer3dView.cpp
inline CObjectViewer3dDoc* CObjectViewer3dView::GetDocument()
   { return (CObjectViewer3dDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OBJECTVIEWER3DVIEW_H__439861ED_E981_11D4_83CE_004033E136DA__INCLUDED_)
